/*
 * Copyright 2014 Petre Eftime
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package ndk.lab4.task2;

import java.io.File;

import android.os.AsyncTask;
import android.os.Bundle;
import android.app.Activity;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

public class MainActivity extends Activity {

	TextView tv1;
	EditText ed1;
	File file;
	
	static {
		System.loadLibrary("Lab4_Task2");
	}
	
	class WriteTask extends AsyncTask<String, Object, Object> {

		@Override
		protected void onPreExecute() {
			super.onPreExecute();
		}
		
		@Override
		protected Object doInBackground(String... params) {
			write(params[0], params[1]);
			return null;
		}
		
		@Override
		protected void onPostExecute(Object result) {
			super.onPostExecute(result);
		}
	}

	class ReadTask extends AsyncTask<String, Object, String> {

		@Override
		protected void onPreExecute() {
			super.onPreExecute();
			tv1.setText("Task started");
		}
		
		@Override
		protected String doInBackground(String... params) {
			return read(params[0]);
		}
		
		@Override
		protected void onPostExecute(String result) {
			super.onPostExecute(result);
			tv1.setText(result);
		}
	}

	
	native void write(String file, String text);
	native String read(String file);
	
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        file = new File(getFilesDir(), "test");
        tv1 = (TextView) findViewById(R.id.tv1);
        ed1 = (EditText) findViewById(R.id.ed1);
        
        Button b1 = (Button) findViewById(R.id.button1);
        Button b2 = (Button) findViewById(R.id.button2);
        
        b1.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				WriteTask t = new WriteTask();
				t.execute(file.getAbsolutePath(), ed1.getText().toString());
			}
		});
        
        b2.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				ReadTask t = new ReadTask();
				t.execute(file.getAbsolutePath());
			}
		});
    }
  
}
